package xyz.joethei.studium.algodat.praktikum.blatt2;

import org.jetbrains.annotations.NotNull;

import java.util.Iterator;

public class LinkedList<E> implements List<E> {
	private class Wrapper {
		E e;
		Wrapper succ;

		Wrapper(E e) {
			this.e = e;
			succ = null;
		}
	}

	private Wrapper first;
	private Wrapper last;
	private int size;

	LinkedList() {
		first = null;
		last = null;
		size = 0;
	}

	public boolean add(E e) {
		Wrapper w = new Wrapper(e);
		if (size == 0) {
			first = w;
			last = w;
		} else {
			last.succ = w;
			last = w;
		}
		size++;
		return true;
	}

	public E get(int index) {
		Wrapper wRun;
		if (index < 0 || index >= size) {
			throw new IndexOutOfBoundsException();
		}
		wRun = this.first;
		for (int iRun = 0; iRun < index; iRun++) {
			wRun = wRun.succ;
		}
		return wRun.e;
	}

	public int size() {
		return size;
	}

	@Override
	public E remove(int index) {
		E e = get(index);
		Wrapper run = this.first;
		if(index >= size || index < 0) {
			throw new IndexOutOfBoundsException();
		}
		size--;
		if(index == 0) {
			first = first.succ;
		}else {
			for (int i = 0; i < index - 1; i++) {
				run = run.succ;
			}
			run.succ = run.succ.succ;

			if(index == size) {
				last = run;
			}
		}
		return e;
	}

	@Override
	public boolean remove(Object o) {
		return false;
	}

	@Override
	public int indexOf(E e) {
		return 0;
	}

	@NotNull
	public Iterator<E> iterator() {
		return new Iterator<E>() {
			Wrapper next = first;
			Wrapper current;

			public boolean hasNext() {
				return next != null;
			}

			public E next() {
				current = next;
				if (next != null) {
					next = next.succ;
				}
				return current.e;
			}

			public void remove() {
				throw new UnsupportedOperationException();
			}
		};
	}

}
