package xyz.joethei.studium.algodat.praktikum;

import org.junit.jupiter.api.Test;
import xyz.joethei.studium.algodat.praktikum.blatt2.List;
import xyz.joethei.studium.algodat.praktikum.blatt2.RingList;

import java.util.Optional;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

class RingListTest {

    @Test
    void add()  {
        List<Integer> rList = new RingList<>();
        for (int i = 1; i <= 10; i++) {
            rList.add(i * i);
        }
        assertEquals(Optional.of(1), Optional.of(rList.get(0)));
        assertEquals(Optional.of(4), Optional.of(rList.get(1)));
        assertEquals(Optional.of(9), Optional.of(rList.get(2)));
        assertEquals(Optional.of(16), Optional.of(rList.get(3)));
        assertEquals(Optional.of(25), Optional.of(rList.get(4)));
        assertEquals(Optional.of(36), Optional.of(rList.get(5)));
        assertEquals(Optional.of(49), Optional.of(rList.get(6)));
        assertEquals(Optional.of(64), Optional.of(rList.get(7)));
        assertEquals(Optional.of(81), Optional.of(rList.get(8)));
        assertEquals(Optional.of(100), Optional.of(rList.get(9)));
    }

    @Test
    void size() {
        List<Integer> rList = new RingList<>();
        for (int i = 1; i <= 10; i++) {
            rList.add(i * i);
        }
        assertEquals(10, rList.size());
    }


    @Test
    void removeIndex() {
        List<Integer> rList = new RingList<>();
        for (int i = 1; i <= 10; i++) {
            rList.add(i * i);
        }
        assertEquals(Optional.of(1), Optional.of(rList.remove(0)));
        assertEquals(9, rList.size());
        assertEquals(Optional.of(36), Optional.of(rList.remove(4)));
        assertEquals(8, rList.size());
        assertEquals(Optional.of(true), Optional.of(rList.remove((Integer) 100)));
        assertTrue(rList.get(4) != 36);
    }

    @Test
    void removeObject() {
        List<Integer> rList = new RingList<>();
        for (int i = 1; i <= 10; i++) {
            rList.add(i * i);
        }

        assertTrue(rList.remove(Integer.valueOf(9)));
        assertFalse(rList.remove(Integer.valueOf(5)));
        assertEquals(9, rList.size());
        assertEquals(-1, rList.indexOf(9));
    }

    @Test
    void indexOf() {
        List<Integer> rList = new RingList<>();
        for (int i = 1; i <= 10; i++) {
            rList.add(i * i);
        }
        assertEquals(0, rList.indexOf(1));
        assertEquals(1, rList.indexOf(4));
        assertEquals(2, rList.indexOf(9));
        assertEquals(3, rList.indexOf(16));
    }


}